// LOCViewerDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "LOCViewer.h"
#include "layman.h"
#include "LOCViewerDlg.h"
#include "DlgProgress.h"
#include <io.h>
#include <direct.h>

int FolderDlg(HWND hwnd,const char* title,char* cur);

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLOCViewerDlg _CAO

CLOCViewerDlg::CLOCViewerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLOCViewerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLOCViewerDlg)
	m_loc1 = 0;
	m_loc2 = 0;
	m_loc3 = 0;
	m_files = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	int		i;
	for (i=0;i<E_SIZE;++i) m_bWhc[i] = false;
}

void CLOCViewerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLOCViewerDlg)
	DDX_Control(pDX, IDC_FOLDER2, m_folder2);
	DDX_Control(pDX, IDC_FOLDER1, m_folder1);
	DDX_Control(pDX, IDC_LIST, m_list);
	DDX_Text(pDX, IDC_LOC1, m_loc1);
	DDX_Text(pDX, IDC_LOC2, m_loc2);
	DDX_Text(pDX, IDC_LOC3, m_loc3);
	DDX_Text(pDX, IDC_FILES, m_files);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLOCViewerDlg, CDialog)
	//{{AFX_MSG_MAP(CLOCViewerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_VIEW_UPDATE, OnViewUpdate)
	ON_WM_DESTROY()
	ON_WM_CONTEXTMENU()
	ON_BN_CLICKED(IDC_REF1, OnRef1)
	ON_BN_CLICKED(IDC_REF2, OnRef2)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST, OnDblclkList)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_REPORT, OnReport)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST, OnColumnclickList)
	ON_COMMAND(ID_VIEW_OPEN1, OnViewOpen1)
	ON_COMMAND(ID_VIEW_OPEN2, OnViewOpen2)
	ON_COMMAND(ID_VIEW_SELALL, OnViewSelall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLOCViewerDlg bZ[W nh

BOOL CLOCViewerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TCYpɌ݈ʒuo
	m_lay.SetType(GetDlgItem(IDC_LBL_TOTAL));
	m_lay.SetType(GetDlgItem(IDC_FILES));
	m_lay.SetType(GetDlgItem(IDC_LOC1));
	m_lay.SetType(GetDlgItem(IDC_LOC2));
	m_lay.SetType(GetDlgItem(IDC_LOC3));
	m_lay.SetType(GetDlgItem(IDOK),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_REPORT),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_LIST),CLayoutManager::FreeSize,CLayoutManager::FreeSize);
	m_lay.SetType(&m_folder1,CLayoutManager::FreeSize,CLayoutManager::Default);
	m_lay.SetType(&m_folder2,CLayoutManager::FreeSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_REF1),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_REF2),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.Reset();

	CWinApp* pApp = AfxGetApp();
	m_folder1.SetAllString(pApp->GetProfileString("Settings","OldFolder",""));
	m_folder2.SetAllString(pApp->GetProfileString("Settings","NewFolder",""));
	int		i,cx,cy,wid[E_SIZE];
	const char* tit[] = {"","̧ٖ","ǉ","폜","LOC"};
	ASSERT(E_SIZE == sizeof(tit)/sizeof(*tit));
	CString	s;
	CRect	r;
	GetWindowRect(&r);
	s.Format("%d %d 15 140 60 60 60",r.Width(),r.Height());
	sscanf(pApp->GetProfileString("Settings","WindowInfo",s),
		"%d %d %d %d %d %d %d",&cx,&cy,wid,wid+1,wid+2,wid+3,wid+4);
	SetWindowPos(0,0,0,cx,cy,SWP_NOZORDER | SWP_NOACTIVATE | SWP_NOMOVE);
	for (i=0;i<E_SIZE;++i)
		m_list.InsertColumn(i,tit[i],i<=E_FILE ? LVCFMT_LEFT : LVCFMT_RIGHT,wid[i],i);
	ListView_SetExtendedListViewStyle(m_list.m_hWnd,LVS_EX_FULLROWSELECT);
	OnOK();

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CLOCViewerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CLOCViewerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CLOCViewerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

int CLOCViewerDlg::SetFiles(CMapData& v,
		CComboBoxAuto& de,const char* mes,int ff)
{
	_finddata_t	fd;
	long		h;
	char		fnam[_MAX_FNAME],ext[_MAX_EXT];
	CString		s = de.toString();
	if (s.IsEmpty()) return 0;
	if (chdir(s)) {
		if (IsWindowVisible()) {
			AfxMessageBox(mes);
			de.SetFocus();
			de.SetEditSel(0,-1);
		}
		return 1;
	}
	if ((h = _findfirst("*.*",&fd)) == -1L)
		return 0;
	do {
		_tsplitpath(fd.name,0,0,fnam,ext);
		if (strcmp(ext,".h") && strcmp(ext,".c") && strcmp(ext,".cpp"))
			continue;
		strcat(fnam,ext);
		v[fnam] |= ff;
	} while (_findnext(h,&fd) == 0);
	_findclose(h);
	return 0;
}

void CountLoc(const char* dir1,const char* dir2,const char* fnam,
		int& k1,int& k2,int& k3);
void CLOCViewerDlg::OnOK() 
{
	CCtLoc			loc;
	vector<CCtLoc>	vloc;
	CMapData		fdt;
	CMapData::iterator	it;
	CString			s,f1,f2;
	int				i,k,n,n1,n2;
	CWaitCursor		dmy;
	const char*		mk[] = {"?","-","+",""};
	UpdateData();
	if (SetFiles(fdt,m_folder1,"̫ނJ܂",1)) return;
	if (SetFiles(fdt,m_folder2,"V̫ނJ܂",2)) return;
	f1 = m_folder1.toString();
	f2 = m_folder2.toString();
	m_list.LockWindowUpdate();
	m_list.DeleteAllItems();
	n = _MAX(1U,fdt.size());
	MSG				msg;
	CDlgProgress	dlg;
	dlg.Create(this);
	dlg.ShowWindow(SW_SHOW);
	n1 = n2 = 0;
	for (i=0, it=fdt.begin();it!=fdt.end();++it, ++i) {
		dlg.m_prog.SetPos(i*100/n);
		while (::PeekMessage(&msg,0,0,0,PM_REMOVE)) {
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}
		if (!dlg.IsWindowVisible()) {
			AfxMessageBox("f܂");
			break;
		}
		CountLoc(f1,f2,it->first,loc.m_add,loc.m_sub,loc.m_all);
		k = it->second;
		ASSERT(k>=1 && k<=3);
		m_list.InsertItem(i,mk[k]);
		m_list.SetItemText(i,E_FILE,it->first);
		s.Format("%d",loc.m_add);
		m_list.SetItemText(i,E_ADD,s);
		s.Format("%d",loc.m_sub);
		m_list.SetItemText(i,E_SUB,s);
		s.Format("%d",loc.m_all);
		m_list.SetItemText(i,E_LOC,s);
		vloc.push_back(loc);
		s = m_list.GetItemText(i,E_FLG);
		if (s == "+") ++n1;
		else if (s == "-") ++n2;
	}
	m_list.UnlockWindowUpdate();
	m_files.Format("%d (+%d/-%d)",vloc.size()-n2,n1,n2);
	SetTotal(vloc);
}

void CLOCViewerDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CLOCViewerDlg::OnDestroy() 
{
	CWinApp* pApp = AfxGetApp();
	CRect	r;
	CString	s,t;
	int		i,k;
	UpdateData();
	GetWindowRect(&r);
	s.Format("%d %d",r.Width(),r.Height());
	for (i=0;i<E_SIZE;++i) {
		k = m_list.GetColumnWidth(i);
		t.Format(" %d",k);
		s += t;
	}
	pApp->WriteProfileString("Settings","OldFolder",m_folder1.GetAllString());
	pApp->WriteProfileString("Settings","NewFolder",m_folder2.GetAllString());
	pApp->WriteProfileString("Settings","WindowInfo",s);
	CDialog::OnDestroy();
}

void CLOCViewerDlg::SetTotal(const vector<CCtLoc>& v)
{
	int		i,n = v.size();
	m_loc1 = m_loc2 = m_loc3 = 0;
	n;
	for (i=0;i<n;++i) {
		m_loc1 += v[i].m_add;
		m_loc2 += v[i].m_sub;
		m_loc3 += v[i].m_all;
	}
	UpdateData(FALSE);
}

void CLOCViewerDlg::OnViewUpdate() 
{
	CCtLoc			loc;
	vector<CCtLoc>	vloc;
	int				i,k1,k2,k3,n1,n2;
	CString			s;
	k1 = k2 = k3 = n1 = n2 = 0;
	POSITION pos = m_list.GetFirstSelectedItemPosition();
	if (pos) while (pos) {
		i = m_list.GetNextSelectedItem(pos);
		loc.m_add = loc.m_sub = loc.m_all = 0;
		s = m_list.GetItemText(i,E_ADD); sscanf(s,"%d",&loc.m_add);
		s = m_list.GetItemText(i,E_SUB); sscanf(s,"%d",&loc.m_sub);
		s = m_list.GetItemText(i,E_LOC); sscanf(s,"%d",&loc.m_all);
		vloc.push_back(loc);
		s = m_list.GetItemText(i,0);
		if (s == "+") ++n1;
		else if (s == "-") ++n2;
	}
	m_files.Format("%d (+%d/-%d)",vloc.size()-n2,n1,n2);
	SetTotal(vloc);
}

void CLOCViewerDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	CMenu menu;
	VERIFY(menu.LoadMenu(IDR_POPUP_MENU));
	CMenu* pPopup = menu.GetSubMenu(0); 
	ASSERT(pPopup != NULL);
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);
}

void CLOCViewerDlg::UpdateFolder(CComboBoxAuto& de,const char* msg)
{
	char	buf[MAX_PATH];
	strcpy(buf,de.toString());
	if (FolderDlg(this->m_hWnd,msg,buf))
		return;
	de.SetWindowText(buf);
}

void CLOCViewerDlg::OnRef1() {UpdateFolder(m_folder1,"tH_");}
void CLOCViewerDlg::OnRef2() {UpdateFolder(m_folder2,"VtH_");}

void CLOCViewerDlg::OpenFile(const char* dir)
{
	CString		s;
	POSITION	pos = m_list.GetFirstSelectedItemPosition();
	if (!pos) return;
	int			i = m_list.GetNextSelectedItem(pos);
	s = dir;
	s += '\\';
	s += m_list.GetItemText(i,1);
	ShellExecute(0,"open","notepad.exe",s,0,SW_SHOW);
}

void CLOCViewerDlg::OnViewOpen1() 
{
	OpenFile(m_folder1.toString());
}

void CLOCViewerDlg::OnViewOpen2() 
{
	OpenFile(m_folder2.toString());
}

void CLOCViewerDlg::OnDblclkList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnViewOpen2();
	*pResult = 0;
}

void CLOCViewerDlg::OnSize(UINT nType, int cx, int cy) 
{
	m_lay.Layout();
}

void CLOCViewerDlg::OnReport() 
{
	CFileDialog	dlg(FALSE, "txt", 0, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
		"CSV Files(*.csv)|*.csv|All Files(*.*)|*.*||", this);
	if (dlg.DoModal() != IDOK) return;
	CStdioFile	f;
	if (!f.Open(dlg.GetFileName(),CFile::modeCreate|
		CFile::modeWrite|CFile::typeText))
		return;
	int		i,n = m_list.GetItemCount();
	CString	s;
	char	buf[80],buf2[80];
	s.Format("%s %s\n",_strdate(buf),_strtime(buf2));
	f.WriteString(s);
	s.Format("tH_,%s\n",(const char*)m_folder1.toString());
	f.WriteString(s);
	s.Format("VtH_,%s\n",(const char*)m_folder2.toString());
	f.WriteString(s);
	f.WriteString("\n,t@C,ǉ,폜,LOC\n");
	for (i=0;i<n;++i) {
		s.Format("%s,%s,%s,%s,%s\n",
			(const char*)m_list.GetItemText(i,E_FLG),
			(const char*)m_list.GetItemText(i,E_FILE),
			(const char*)m_list.GetItemText(i,E_ADD),
			(const char*)m_list.GetItemText(i,E_SUB),
			(const char*)m_list.GetItemText(i,E_LOC));
		f.WriteString(s);
	}
	s.Format("Total,%s,%d,%d,%d\n",(const char*)m_files,m_loc1,m_loc2,m_loc3);
	f.WriteString(s);
}

static int CALLBACK CompareFunc(LPARAM l1,LPARAM l2,LPARAM i)
{
	CLOCViewerDlg* pDlg = (CLOCViewerDlg*)AfxGetMainWnd();
	CString	s1 = pDlg->m_list.GetItemText(l1,i);
	CString	s2 = pDlg->m_list.GetItemText(l2,i);
	int	res;
	if (i <= CLOCViewerDlg::E_FILE) res = s1.CompareNoCase(s2);
	else res = atoi(s1) - atoi(s2);
	return pDlg->m_bWhc[i] ? res : -res;
}

void CLOCViewerDlg::OnColumnclickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	*pResult = 0;
	CWaitCursor		dmy;
	int		i,n = m_list.GetItemCount();
	for (i=0;i<n;++i) m_list.SetItemData(i,i);
	i = pNMListView->iSubItem;
	m_list.SortItems(&CompareFunc,i);
	m_bWhc[i] = !m_bWhc[i];
}

void CLOCViewerDlg::OnViewSelall() 
{
	int		i,n = m_list.GetItemCount();
	for (i=0;i<n;++i) 
		m_list.SetItemState(i,LVIS_SELECTED,LVIS_SELECTED);
}
