// LOCViewerDlg.h : wb_[ t@C
//

#if !defined(HEADER_LOCVIEWERDLG_H)
#define HEADER_LOCVIEWERDLG_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ComboBoxAuto.h"
#pragma warning (disable : 4786)
#include <vector>
#include <map>
#include <string>
using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CLOCViewerDlg _CAO

namespace {
struct CCtLoc {
	int		m_add;
	int		m_sub;
	int		m_all;
};

struct CMapLess {
	bool operator()(const CString& s1,const CString& s2)const{
		return s1.CompareNoCase(s2) < 0;
	}
};
}

class CLOCViewerDlg : public CDialog
{
public:
	typedef map<CString,int,CMapLess> CMapData;
	enum {E_FLG=0, E_FILE=1, E_ADD=2, E_SUB=3, E_LOC=4, E_SIZE=5};
	bool			m_bWhc[E_SIZE];
	CLayoutManager	m_lay;
	CLOCViewerDlg(CWnd* pParent = NULL);	// W̃RXgN^
	void UpdateFolder(CComboBoxAuto& s,const char* msg);
	int SetFiles(CMapData& v,CComboBoxAuto& de,const char* mes,int ff);
	void SetTotal(const vector<CCtLoc>& v);
	void OpenFile(const char* dir);

// _CAO f[^
	//{{AFX_DATA(CLOCViewerDlg)
	enum { IDD = IDD_LOCVIEWER_DIALOG };
	CComboBoxAuto	m_folder2;
	CComboBoxAuto	m_folder1;
	CListCtrl	m_list;
	int		m_loc1;
	int		m_loc2;
	int		m_loc3;
	CString	m_files;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CLOCViewerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CLOCViewerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnViewUpdate();
	afx_msg void OnDestroy();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnRef1();
	afx_msg void OnRef2();
	afx_msg void OnDblclkList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnReport();
	afx_msg void OnColumnclickList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnViewOpen1();
	afx_msg void OnViewOpen2();
	afx_msg void OnViewSelall();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(HEADER_LOCVIEWERDLG_H)
