// LOC JEg
// RgŁA; : # { ̐JEg
//  \+͂̂܂ܓǂ
//  "or' ͓s܂œǂݔ΂
//  // ͉s܂œǂݔ΂
//  /*  */ ܂œǂݔ΂
#include "stdafx.h"
#include <cstdio>
#include <cstring>
#include <direct.h>
#include <sys/stat.h>
#pragma warning (disable : 4786)
#include <vector>
using namespace std;

typedef vector<int> CLineData;

static void PushLine(FILE* f,vector<char>& ct,CLineData& v)
{
	int		c, i = 0;
	struct _stat st;
	_fstat(fileno(f),&st);
	ct.resize(st.st_size);
	v.push_back(0);
	while ((c = getc(f)) != EOF) {
		ct[i++] = c;
		if (c == '\n') v.push_back(i);
	}
	ct.erase(ct.begin()+i,ct.end()); // sƂ̂
}

static bool SameLine(vector<char>& ct1,vector<char>& ct2,int i1,int i2)
{
	int		c1,c2,n1,n2;
	n1 = ct1.size();
	n2 = ct2.size();
	while (true) {
		c1 = i1 < n1 ? ct1[i1] : -1;
		c2 = i2 < n2 ? ct2[i2] : -1;
		if (c1 == '\n') c1 = -1;
		if (c2 == '\n') c2 = -1;
		if (c1 == -1 && c2 == -1) break;
		if (c1 != c2)
			return false;
		++i1;
		++i2;
	}
	return true;
}

void ChkLine(FILE* f,FILE* g,vector<char>& ct1,
	vector<char>& ct2,CLineData& v1,CLineData& v2)
{
	ct1.clear();
	ct2.clear();
	if (f) PushLine(f,ct1,v1);
	if (g) PushLine(g,ct2,v2);
	int		i,j,m,n, js = 0;
	n = v1.size();
	m = v2.size();
	if (f && g) {
		for (i=0;i<n;++i) {
			for (j=js;j<m;++j) if (v2[j] >= 0) {
				if (SameLine(ct1,ct2,v1[i],v2[j])) {
					v1[i] = v2[j] = -1;
					if (js == j) ++js;
					break;
				}
			}
		}
	}
	for (i=0;i<n;++i) v1[i] = v1[i]<0 ? 1 : 0;
	for (j=0;j<m;++j) v2[j] = v2[j]<0 ? 1 : 0;
}

inline void LineAdd(const CLineData& v,int line,int& n1,int& n2)
{
	++(line < v.size() ? (v[line] ? n1 : n2) : n2);
}

inline int GetC(vector<char>& ct,int& i)
{
	return i < ct.size() ? ct[i++] : -1;
}

static void GetLOC(vector<char>& ct,const CLineData& v,int& n1,int& n2)
{
	int		i,c,cc,line;
	n1 = n2 = i = line = 0;
	while ((c = GetC(ct,i)) != -1) {
		if (c == '\\') {
			if ((c = GetC(ct,i)) == -1) break;
		} else if (c == '"' || c == '\'') {
			cc = c;
			while ((c = GetC(ct,i)) != -1) {
				if (c == cc || c == '\n') break;
				if (c == '\\') {
					if ((c = GetC(ct,i)) == -1) break;
					if (c == '\n') ++line;
				}
			}
		} else if (c == '/') {
			if ((c = GetC(ct,i)) == -1) break;
			if (c == '/') {
				while ((c = GetC(ct,i)) != -1)
					if (c == '\n') break;
			} else if (c == '*') {
				while ((c = GetC(ct,i)) != -1) {
					if (c == '*') {
						if ((c = GetC(ct,i)) == -1) break;
						if (c == '/') break;
						else --i;
					}
				}
			} else {
				--i;
			}
		}
		if (c == '\n') {
			++line;
			continue;
		}
		if (c == '#') {
			if ((c = GetC(ct,i)) != -1) {
				if (c != '#') {
					LineAdd(v,line,n1,n2);
					--i;
				}
			}
		} else if (c == '{') {
			LineAdd(v,line,n1,n2);
		} else if (c == ';') {
			LineAdd(v,line,n1,n2);
		} else if (c == ':') {
			if ((c = GetC(ct,i)) != -1) {
				if (c != ':') {
					LineAdd(v,line,n1,n2);
					--i;
				}
			}
		}
	}
}

void CountLoc(const char* dir1,const char* dir2,const char* fnam,
		int& nAdd,int& nSub,int& nAll)
{
	FILE	*f = 0,*g = 0;
	int		n11,n12,n21,n22;
	struct stat	st1,st2;
	st1.st_size = st2.st_size = -1;
	if (*dir1 && !chdir(dir1)) {
		f = fopen(fnam,"r");
		stat(fnam,&st1);
	}
	if (*dir2 && !chdir(dir2)) {
		g = fopen(fnam,"r");
		stat(fnam,&st2);
	}
	bool b = st1.st_size >= 0 && st1.st_size == st2.st_size
		&& st1.st_mtime == st2.st_mtime;	// t@C
	CLineData	v1,v2;
	vector<char>	ct1,ct2;
	ChkLine(b ? 0 : f,g,ct1,ct2,v1,v2);
	if (f) fclose(f);
	if (g) fclose(g);
	n11 = n12 = n21 = n22 = 0;
	if (!b)
		GetLOC(ct1,v1,n11,n12);
	GetLOC(ct2,v2,n21,n22);
	nAll = n21 + n22;
	nAdd = nSub = 0;
	if (!b || !*dir1) {
		nAdd = n22;
		nSub = n12;
	}
}